from odoo import models

class DeliveryCarrier(models.Model):
    _inherit = 'delivery.carrier'

    # Override to avoid shipping fees on free gifts
    def rate_shipment(self, order):
        res = super().rate_shipment(order)
        if res and res['price'] and order._compute_amount_total_without_delivery() == 0.0:
            res['price'] = 0.0
        return res
